dim invApp as Application
dim irx as TransientGeometry
dim storePath
Dim PI
dim sketchDic as object

Private Function CreateSketch1_3(partCompDef As PartComponentDefinition)
	Dim firstPoint as SketchPoint
	Dim lastPoint as SketchPoint
set sketchNormal=irx.CreateUnitVector(0,0,1)
sketchDic.add "Sketch_1",sketchNormal
set feat3=createSketch(partCompDef,"Sketch_1",0,0,0,1,0,0,0,1,0)
set lastPoint=AddSketchLine(feat3,-5.35,0,0,-3.7,0,0,firstPoint,lastPoint,1)
set lastPoint=AddSketchLine(feat3,-3.7,0,0,-3.7,2.55,0,firstPoint,lastPoint,0)
set lastPoint=AddSketchArc(feat3,-3.7,2.55,0,-3.612132034356,2.762132034356,0,-3.4,2.85,0,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat3,-3.4,2.85,0,3.4,2.85,0,firstPoint,lastPoint,0)
set lastPoint=AddSketchArc(feat3,3.4,2.85,0,3.612132034356,2.762132034356,0,3.7,2.55,0,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat3,3.7,2.55,0,3.7,0,0,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat3,3.7,0,0,5.35,0,0,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat3,5.35,0,0,5.35,1.3,0,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat3,5.35,1.3,0,4.1952994616207,3.3,0,firstPoint,lastPoint,0)
set lastPoint=AddSketchArc(feat3,4.1952994616207,3.3,0,3.9756842193501,3.5196152422707,0,3.6756842193501,3.6,0,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat3,3.6756842193501,3.6,0,-3.6756842193501,3.6,0,firstPoint,lastPoint,0)
set lastPoint=AddSketchArc(feat3,-3.6756842193501,3.6,0,-3.9756842193501,3.5196152422707,0,-4.1952994616207,3.3,0,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat3,-4.1952994616207,3.3,0,-5.35,1.3,0,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat3,-5.35,1.3,0,-5.35,0,0,firstPoint,lastPoint,2)
feat3.Profiles.AddForSolid
Set CreateSketch1_3=feat3
End Function

Private Function CreateSketch1_6(partCompDef As PartComponentDefinition)
	Dim firstPoint as SketchPoint
	Dim lastPoint as SketchPoint
set sketchNormal=irx.CreateUnitVector(0,1,0)
sketchDic.add "Sketch_4",sketchNormal
set feat6=createSketch(partCompDef,"Sketch_4",0,1.2999,0,1,1.2999,0,0,1.2999,-1)
set lastPoint=AddSketchArc(feat6,3.975,1.2999,0.4875,4.062867965644,1.2999,0.69963203435596,4.275,1.2999,0.7875,firstPoint,lastPoint,1)
set lastPoint=AddSketchLine(feat6,4.275,1.2999,0.7875,5.55,1.2999,0.7875,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat6,5.55,1.2999,0.7875,5.55,1.2999,-0.7875,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat6,5.55,1.2999,-0.7875,4.275,1.2999,-0.7875,firstPoint,lastPoint,0)
set lastPoint=AddSketchArc(feat6,4.275,1.2999,-0.7875,4.062867965644,1.2999,-0.69963203435596,3.975,1.2999,-0.4875,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat6,3.975,1.2999,-0.4875,3.975,1.2999,0.4875,firstPoint,lastPoint,2)
feat6.Profiles.AddForSolid
Set CreateSketch1_6=feat6
End Function

Private Function CreateSketch1_8(partCompDef As PartComponentDefinition)
	Dim firstPoint as SketchPoint
	Dim lastPoint as SketchPoint
set sketchNormal=irx.CreateUnitVector(0,1,0)
sketchDic.add "Sketch_5",sketchNormal
set feat8=createSketch(partCompDef,"Sketch_5",0,1.2999,0,1,1.2999,0,0,1.2999,-1)
set lastPoint=AddSketchLine(feat8,-5.55,1.2999,0.7875,-4.275,1.2999,0.7875,firstPoint,lastPoint,1)
set lastPoint=AddSketchArc(feat8,-4.275,1.2999,0.7875,-4.062867965644,1.2999,0.69963203435596,-3.975,1.2999,0.4875,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat8,-3.975,1.2999,0.4875,-3.975,1.2999,-0.4875,firstPoint,lastPoint,0)
set lastPoint=AddSketchArc(feat8,-3.975,1.2999,-0.4875,-4.062867965644,1.2999,-0.69963203435596,-4.275,1.2999,-0.7875,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat8,-4.275,1.2999,-0.7875,-5.55,1.2999,-0.7875,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat8,-5.55,1.2999,-0.7875,-5.55,1.2999,0.7875,firstPoint,lastPoint,2)
feat8.Profiles.AddForSolid
Set CreateSketch1_8=feat8
End Function

Private Function CreateSketch1_11(partCompDef As PartComponentDefinition)
	Dim firstPoint as SketchPoint
	Dim lastPoint as SketchPoint
set sketchNormal=irx.CreateUnitVector(1,0,0)
sketchDic.add "Sketch_2",sketchNormal
set feat11=createSketch(partCompDef,"Sketch_2",4.7,0,0,4.7,0,-1,4.7,1,0)
set centerStartPk=feat11.SketchPoints.Add(convertToSketchSpace(feat11,4.7,0,0))
set centerEndPk=feat11.SketchPoints.Add(convertToSketchSpace(feat11,4.7,1.3,0))
feat11.SketchLines.AddByTwoPoints centerStartPk,centerEndPk
set lastPoint=AddSketchLine(feat11,4.7,1.3,0,4.7,1.3,-0.525,firstPoint,lastPoint,1)
set lastPoint=AddSketchLine(feat11,4.7,1.3,-0.525,4.7,0.6,-0.525,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat11,4.7,0.6,-0.525,4.7,0.6,-0.325,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat11,4.7,0.6,-0.325,4.7,0,-0.325,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat11,4.7,0,-0.325,4.7,0,0,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat11,4.7,0,0,4.7,1.3,0,firstPoint,lastPoint,2)
feat11.Profiles.AddForSolid
Set CreateSketch1_11=feat11
End Function

Private Function CreateSketch1_13(partCompDef As PartComponentDefinition)
	Dim firstPoint as SketchPoint
	Dim lastPoint as SketchPoint
set sketchNormal=irx.CreateUnitVector(1,0,0)
sketchDic.add "Sketch_3",sketchNormal
set feat13=createSketch(partCompDef,"Sketch_3",-4.7,0,0,-4.7,0,-1,-4.7,1,0)
set centerStartPk=feat13.SketchPoints.Add(convertToSketchSpace(feat13,-4.7,0,0))
set centerEndPk=feat13.SketchPoints.Add(convertToSketchSpace(feat13,-4.7,1.3,0))
feat13.SketchLines.AddByTwoPoints centerStartPk,centerEndPk
set lastPoint=AddSketchLine(feat13,-4.7,1.3,0,-4.7,1.3,-0.525,firstPoint,lastPoint,1)
set lastPoint=AddSketchLine(feat13,-4.7,1.3,-0.525,-4.7,0.6,-0.525,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat13,-4.7,0.6,-0.525,-4.7,0.6,-0.325,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat13,-4.7,0.6,-0.325,-4.7,0,-0.325,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat13,-4.7,0,-0.325,-4.7,0,0,firstPoint,lastPoint,0)
set lastPoint=AddSketchLine(feat13,-4.7,0,0,-4.7,1.3,0,firstPoint,lastPoint,2)
feat13.Profiles.AddForSolid
Set CreateSketch1_13=feat13
End Function

Private Sub getLocalOptions()
storePath = InputBox("Enter Path (e.g. c:\cadfiles\ )")
l=len(storePath)
if l<>0 then
  lastChar=mid(storePath,l,1)
  if lastChar<>"\" then
    storePath=storePath & "\"
  end if
end if
end sub
Private Function convertToSketchSpace(sketch, pointX, pointY, pointZ)
Dim myPoint As Point
Set myPoint = irx.CreatePoint(pointX, pointY, pointZ)
Set convertToSketchSpace = sketch.ModelToSketchSpace(myPoint)
End Function
Private Function createSketch(partCompDef As PartComponentDefinition, sketchName as String,tx, ty, tz, xx, xy, xz, yx, yy, yz)
Dim pk1, pk2, pk3 As point
Set pk1 = irx.CreatePoint(tx, ty, tz)
Set pk2 = irx.CreatePoint(xx, xy, xz)
Set pk3 = irx.CreatePoint(yx, yy, yz)
Dim wpk1, wpk2, wpk3 As WorkPoint 
Set wpk1 = partCompDef.WorkPoints.AddFixed(pk1)
Set wpk2 = partCompDef.WorkPoints.AddFixed(pk2)
Set wpk3 = partCompDef.WorkPoints.AddFixed(pk3)
wpk1.Visible=false
wpk2.Visible=false
wpk3.Visible=false
Dim createPlane As Workplane
Set createPlane = partCompDef.WorkPlanes.AddByThreePoints(wpk1, wpk2, wpk3, True)
Dim createAxis As WorkAxis
Set AxisVector = irx.CreateUnitVector(xx - tx, xy - ty, xz - tz)
Set createAxis = partCompDef.WorkAxes.AddFixed(pk1, AxisVector)
createAxis.visible=false
Dim sketch As object
Set sketch = partCompDef.Sketches.AddWithOrientation(createPlane, createAxis, False, True, wpk1, False)
sketch.visible=false
sketch.name=sketchName
If (invApp.SoftwareVersion.Major <= 6) Then
  createPlane.visible=false
end if
Set createSketch = sketch
end function
Private Sub ExtrudeSketch(partCompDef,sketch,dist,side As PartFeatureExtentDirectionEnum,op As PartFeatureOperationEnum,draft As String)
Dim planeNormal As UnitVector
Dim sketchNormal As UnitVector
Set planeNormal = sketch.PlanarEntityGeometry.Normal
Set sketchNormal = sketchDic.Item(sketch.name)
If (sketchNormal.IsEqualTo(planeNormal) = False) Then
If (side = kNegativeExtentDirection) Then
side = kPositiveExtentDirection
ElseIf (side = kPositiveExtentDirection) Then
side = kNegativeExtentDirection
End If
End If
Set extrudeFeat = partCompDef.Features.ExtrudeFeatures.AddByDistanceExtent(sketch.Profiles(1), dist, side, op, draft)
end sub
Private Sub RotateSketch(partCompDef,sketch,angle,side As PartFeatureExtentDirectionEnum,op As PartFeatureOperationEnum)
Dim planeNormal As UnitVector
Dim sketchNormal As UnitVector
Set planeNormal = sketch.PlanarEntityGeometry.Normal
Set sketchNormal = sketchDic.Item(sketch.name)
If (sketchNormal.IsEqualTo(planeNormal) = False) Then
If (side = kNegativeExtentDirection) Then
side = kPositiveExtentDirection
ElseIf (side = kPositiveExtentDirection) Then
side = kNegativeExtentDirection
End If
End If
set axis=sketch.SketchLines(1)
Set RotateFeat = partCompDef.Features.RevolveFeatures.AddByAngle(sketch.Profiles(1), axis, angle/180*PI, side, op)
end sub
Private Sub setPartColor(partDocument, red, green, blue, colorName)
Dim style As RenderStyle
Set style = partDocument.RenderStyles.Add(colorName)
style.SetAmbientColor red, green, blue
partDocument.ActiveRenderStyle = style
End Sub
Private Function AddSketchLine(ByVal sketch As PlanarSketch, startx As Double, starty As Double, startz As Double, endx As Double, endy As Double, endz As Double, firstPoint As SketchPoint, lastPoint As SketchPoint, pos As Integer)
Dim startPoint As SketchPoint
Dim endPoint As SketchPoint
If (pos = 1) Then
Set startPoint = sketch.SketchPoints.Add(convertToSketchSpace(sketch, startx, starty, startz))
Set endPoint = sketch.SketchPoints.Add(convertToSketchSpace(sketch, endx, endy, endz))
Set firstPoint = startPoint
ElseIf (pos = 2) Then
Set startPoint = lastPoint
Set endPoint = firstPoint
Else
Set startPoint = lastPoint
Set endPoint = sketch.SketchPoints.Add(convertToSketchSpace(sketch, endx, endy, endz))
Set lastPoint = endPoint
End If
Set lines = sketch.SketchLines
lines.AddByTwoPoints startPoint, endPoint
Set AddSketchLine = endPoint
End Function
Private Function AddSketchArc(ByVal sketch As PlanarSketch, startx As Double, starty As Double, startz As Double, midx As Double, midy As Double, midz As Double, endx As Double, endy As Double, endz As Double, firstPoint As SketchPoint, lastPoint As SketchPoint, pos As Integer)
Dim startPoint As SketchPoint
Dim midPoint As SketchPoint
Dim endPoint As SketchPoint
Set midPoint = sketch.SketchPoints.Add(convertToSketchSpace(sketch, midx, midy, midz))
If (pos = 1) Then
Set startPoint = sketch.SketchPoints.Add(convertToSketchSpace(sketch, startx, starty, startz))
Set endPoint = sketch.SketchPoints.Add(convertToSketchSpace(sketch, endx, endy, endz))
Set firstPoint = startPoint
ElseIf (pos = 2) Then
Set startPoint = lastPoint
Set endPoint = firstPoint
Else
Set startPoint = lastPoint
Set endPoint = sketch.SketchPoints.Add(convertToSketchSpace(sketch, endx, endy, endz))
Set lastPoint = endPoint
End If
Set arcs = sketch.SketchArcs
arcs.AddByThreePoints startPoint,midPoint.Geometry,endPoint
Set AddSketchArc = endPoint
End Function
Private Sub CreatePart0
sketchDic.RemoveAll
Dim sketchNormal As UnitVector
searchName=Dir(storePath & "ELESA_Buegelgriff_GN_528_PA_94_SW.ipt")
if searchName<>"" then
 exit sub
end if
set partDocument=InvApp.Documents.Add(kPartDocumentObject,"",true)
partDocument.UnitsOfMeasure.LengthUnits = kMillimeterLengthUnits
partDocument.UnitsOfMeasure.AngleUnits = kDegreeAngleUnits
dim partCompDef as PartComponentDefinition
set partCompDef=partDocument.ComponentDefinition
set feat3=CreateSketch1_3(partCompDef)
ExtrudeSketch partCompDef,feat3,2.1,kSymmetricExtentDirection,kJoinOperation,"0"
set feat6=CreateSketch1_6(partCompDef)
ExtrudeSketch partCompDef,feat6,3.6,kPositiveExtentDirection,kCutOperation,"0"
set feat8=CreateSketch1_8(partCompDef)
ExtrudeSketch partCompDef,feat8,3.6,kPositiveExtentDirection,kCutOperation,"0"
set feat11=CreateSketch1_11(partCompDef)
set feat13=CreateSketch1_13(partCompDef)
RotateSketch partCompDef,feat11,360,kPositiveExtentDirection,kCutOperation
RotateSketch partCompDef,feat13,360,kPositiveExtentDirection,kCutOperation
If (invApp.SoftwareVersion.Major >= 6) Then
  partDocument.PropertySets.Item("{F29F85E0-4FF9-1068-AB91-08002B27B3D9}").ItemByPropId(kTitleSummaryInformation).Value = "ELESA Buegelgriff GN 528-PA-94-SW"
  partDocument.PropertySets.Item("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").ItemByPropId(kVendorDesignTrackingProperties).Value = "Ganter - Griff"
  partDocument.PropertySets.Item("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").ItemByPropId(kPartNumberDesignTrackingProperties).Value = "ELESA Buegelgriff GN 528-PA-94-SW"
else
  partDocument.PropertySets.Item("Summary Information").ItemByPropId(kTitleSummaryInformation).Value = "ELESA Buegelgriff GN 528-PA-94-SW"
  partDocument.PropertySets.Item("Design Tracking Properties").ItemByPropId(kPartNumberDesignTrackingProperties).Value = "ELESA Buegelgriff GN 528-PA-94-SW"
end if
setPartColor partDocument,175,175,175,"RGB(175,175,175)"
partDocument.SaveAs  storePath & "ELESA_Buegelgriff_GN_528_PA_94_SW.ipt",false
partdocument.Close
End Sub
sub CreateInventorDocument
set invApp=GetObject(,"Inventor.Application")
set irx = invApp.TransientGeometry
PI=3.141592653589793238462643383279
Set sketchDic = CreateObject("Scripting.Dictionary")
getLocalOptions
createPart0
invApp.Documents.Open storePath & "ELESA_Buegelgriff_GN_528_PA_94_SW.ipt"
end sub
